<Manage::FieldContainer
  @title={{@title}}
  @isDisabled={{@isDisabled}}
  @isSaveDisabled={{this.isDisabled}}
  @editablePanel={{@editablePanel}}
  @onEdit={{@onEdit}}
  @onSave={{this.save}}
  @onCancel={{this.cancel}}
  {{did-insert this.setup}}
  class="manage-color-palette"
  ...attributes
>
  <:view>
    <div class="standard-colors">
      {{#each this.colors as |color|}}
        <div class="color d-inline-block me-2 mb-2">
          <label class="form-label color-name" for="{{this.elementId}}-{{color.name}}">{{t color.name}}</label>
          <div class="color-block color-{{color.name}} text-light rounded-3 mb-3" style={{color.style}}>
            {{color.value}}
          </div>
        </div>
      {{/each}}

      <div class="custom-colors">
        {{#each this.customColors as |color|}}
          <div class="color d-inline-block me-2 mb-4">
            <Label class="form-label color-name" @value={{color.name}}>
              <div class="d-flex">
                <div class="color-block color-{{color.name}} text-dark rounded-3 mb-1 me-1" style={{color.lightStyle}}>
                  {{color.lightValue}}
                </div>

                <div class="color-block color-{{color.name}} text-light rounded-3 mb-1 ms-1" style={{color.darkStyle}}>
                  {{color.darkValue}}
                </div>
              </div>
            </Label>
          </div>
        {{/each}}
      </div>
    </div>
  </:view>

  <:edit>
    <div class="standard-colors">
      {{#each this.colors as |color|}}
        <div class="color d-inline-block me-2 mb-2">
          <Label class="form-label color-name" @value={{t color.name}} as |id|>
            <Input::Text
              @type="color"
              class="form-control form-control-color input-color-{{color.name}} mb-3"
              id={{id}}
              @value={{color.value}}
              {{on "input" (fn this.colorInput color.name)}}
              @onChange={{fn this.change color.name}}
            />
          </Label>
        </div>
      {{/each}}
    </div>

    <div class="custom-colors">
      {{#each this.customColors as |color index|}}
        <div class="color d-inline-block me-2 mb-4">
          <Label class="form-label color-name" @value={{t "manage-section.color-name"}} as |id|>
            <Input::Text
              class="form-control input-color-custom-name mb-3"
              id={{id}}
              @value={{color.name}}
              @onChange={{fn this.changeField "name" color}}
            />
          </Label>

          <div class="d-flex">
            <div class="custom-colors flex-fill pe-1">
              <Label class="form-label color-name" @value={{t "manage-section.color-light"}} as |id|>
                <Input::Text
                  @type="color"
                  class="form-control form-control-color-light input-color-{{color.name}}"
                  id={{id}}
                  @value={{color.lightValue}}
                  {{on "input" (fn this.colorFieldInput "lightValue" color)}}
                  @onChange={{fn this.changeField "lightValue" color}}
                />
              </Label>
            </div>

            <div class="custom-colors flex-fill ps-1">
              <Label class="form-label color-name" @value={{t "manage-section.color-dark"}} as |id|>
                <Input::Text
                  @type="color"
                  class="form-control form-control-color-dark input-color-{{color.name}}"
                  id={{id}}
                  @value={{color.darkValue}}
                  {{on "input" (fn this.colorFieldInput "darkValue" color)}}
                  @onChange={{fn this.changeField "darkValue" color}}
                />
              </Label>
            </div>
          </div>
          <button
            class="btn btn-sm btn-outline-danger btn-remove-custom-color mt-3 w-100"
            {{on "click" (fn this.removeCustom index)}}
          >
            <FaIcon @icon="trash" />
          </button>
        </div>
      {{/each}}
    </div>

    <div class="m-2">
      <button type="button" class="btn btn-outline-secondary btn-add-custom-color" {{on "click" this.addCustomColor}}>
        <FaIcon @icon="plus" />
        {{t "manage-section.custom-color"}}
      </button>
    </div>
  </:edit>
</Manage::FieldContainer>